#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <smarttrap.h>
#include <multichanneli2c.h>


extern "C" {
void UserMain(void * pd);
}

const char * AppName="5441xtempsensor";

#define I2C_CHANNEL 0  //Uncomment for channel 0
//#define I2C_CHANNEL 1  //Uncomment for channel 1
//#define I2C_CHANNEL 2  //Uncomment for channel 2 
    //(Note: please see Part Change Notice at http://www.netburner.com/products/core-modules/mod5441x 
    // and ensure you have an I2C2 module or have moved resistor prior to using module 2
//#define I2C_CHANNEL 3  //Uncomment for channel 3
//#define I2C_CHANNEL 4  //Uncomment for channel 4
//#define I2C_CHANNEL 5  //Uncomment for channel 5


#define I2C_TEMP_SENSOR_ADDRESS 0x48

/* Use I2C to read a byte from the specified register on address 0x48 */
uint8_t read8(uint8_t reg) {
    uint8_t rx = 0;
    int status = MultiChannel_I2CSendBuf(I2C_CHANNEL, I2C_TEMP_SENSOR_ADDRESS, &reg, 1, false);
    if ( status != I2C_MASTER_OK )
    	iprintf("Error %d calling I2CSendBuf()\r\n", status);

    status = MultiChannel_I2CRestart(I2C_CHANNEL, I2C_TEMP_SENSOR_ADDRESS, I2C_START_READ);
    if (( status != I2C_OK ) | (status != I2C_NEXT_READ_OK))
        iprintf("Error %d calling I2CRestart()\r\n", status);

    status = MultiChannel_I2CReadBuf(I2C_CHANNEL, I2C_TEMP_SENSOR_ADDRESS, &rx, 1);
    if ( (status != I2C_OK) && (status != I2C_NEXT_READ_OK) )
    	iprintf("Error %d calling I2CReadBuf()\r\n", status );
    return rx;
}

/* Use I2C to write a byte to the specified register on address 0x48 */
uint8_t write8(uint8_t reg, uint8_t value) {

    int status = MultiChannel_I2CSendBuf(I2C_CHANNEL, I2C_TEMP_SENSOR_ADDRESS, &reg, 1, false);
    if ( status != I2C_OK )
    	iprintf("Error calling I2CSendBuf()\r\n");

    status = MultiChannel_I2CRestart(I2C_CHANNEL, I2C_TEMP_SENSOR_ADDRESS, I2C_START_WRITE);
    if (( status != I2C_OK ) | (status != I2C_NEXT_WRITE_OK))
        iprintf("Error %d calling I2CRestart()\r\n", status);

    status = MultiChannel_I2CSendBuf(I2C_CHANNEL, I2C_TEMP_SENSOR_ADDRESS, &value, 1);
    if ( status != I2C_OK )
    	iprintf("Error calling I2CSendBuf()\r\n");

    return status;
}

void UserMain(void * pd) {
    InitializeStack();
    if (EthernetIP == 0) GetDHCPAddress();
    OSChangePrio(MAIN_PRIO);
    EnableAutoUpdate();

    #ifndef _DEBUG
    EnableSmartTraps();
    #endif

    uint8_t Temp;
    MultiChannel_I2CInit(I2C_CHANNEL);

    iprintf("Application started\n");
    while (1) {
        OSTimeDly(2);
        Temp = read8(0x00); //The register 0 on this temp sensor is the given temperature in C.
        iprintf("Temperature from sensor is %d. \r\n", Temp);
    }
}
